% $Author: Vincent Drouard $    $Date: Apr 1, 2016$    $Revision: 1.0 $
%                               
% Copyright: Perception Team, INRIA-Grenoble
% Email: vincent.drouard@inria.fr

% The Head Pose algorithm is described in this paper:      
%  (1) V. Drouard, S. Ba, G. Evangelidis, A. Deleforge, and R. Horaud ,  "Head Pose Estimation via Probabilistic High-Dimensional Regression", IEEE International Conference on Image Processing (ICIP), 2015.



addpath('GLLiM');
addpath('mArrow');
% data_path = 'Prima_samples';

load('theta.mat');

files = dir('images/*.jpg');

for i = 1:length(files)
    frame = imread(['images/' files(i).name]);
    id = fopen(['images/' files(i).name(1:end-3) 'txt']);
    st=fread(id,'*char')';
    fclose(id);
    tmp = str2num(st(28:end-1));
    bbox = [tmp(1)-tmp(3)/2;tmp(2)-tmp(4)/1.5;tmp(1)+tmp(3)/2;tmp(2)+tmp(4)/1.5];
    bbox(1) = max(1,bbox(1));bbox(2) = max(1,bbox(2));bbox(3) = min(size(frame,2),bbox(3));bbox(4) = min(size(frame,1),bbox(4));
    position = [tmp(1);tmp(2)];
    face = frame(round(bbox(2)):round(bbox(4)),...
        round(bbox(1)):round(bbox(3)),:);% extract face from image
    face = histeq(rgb2gray(imresize(face,[64 64])));% resize and convert to grayscale
    hog = [HOG(face,8,[32 32],[2 2]);...
        HOG(face,8,[16 16],[2 2]);...
        HOG(face,8,[8 8],[2 2])];
    id = str2double(files(i).name(7:8));
    p=files(i).name(12:end-4);
    a=find(p=='+' | p=='-');
    gt_pose = [str2double(p(a(1):a(2)-1));str2double(p(a(2):end))];
    est = gllim_inverse_map(hog,theta{id},1);
    displayEstimationPrima(frame,[gt_pose est],repmat(position,1,2),0.7);% display results
    fprintf('Press any key\n');
    pause;
    close all;
end
