% $Author: Vincent Drouard $    $Date: Apr 1, 2016$    $Revision: 1.0 $
%                               
% Copyright: Perception Team, INRIA-Grenoble
% Email: vincent.drouard@inria.fr

% The Head Pose algorithm is described in this paper:      
%  (1) V. Drouard, S. Ba, G. Evangelidis, A. Deleforge, and R. Horaud ,  "Head Pose Estimation via Probabilistic High-Dimensional Regression", IEEE International Conference on Image Processing (ICIP), 2015.

function theta = learnPrima(data,K,Lv)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description: Process the Prima Head Pose database 
%%%%%
%%% INPUT
% data: string containing path to find the data
% K: number of affine transformation to learn in the gllim model
% Lv: dimension of the latent part of x in the gllim model
%%% OUTPUT
% theta: learned model parameters 
%%%%%%%%%%%%%%%%%%%%%%%%%
    cstr.Sigma = 'i*';% constraint on the mapping error covariance matrix (isotropic)
    for i = 1:15
        idx = find(data.index(2,:)~=i);
        theta{i} = gllim(data.pose(2:end,idx),data.features(2:end,idx),K,'cstr',cstr,'maxiter',1,'Lw',Lv);
    end
end
