% $Author: Vincent Drouard $    $Date: Apr 1, 2016$    $Revision: 1.0 $
%                               
% Copyright: Perception Team, INRIA-Grenoble
% Email: vincent.drouard@inria.fr

% The Head Pose algorithm is described in this paper:      
%  (1) V. Drouard, S. Ba, G. Evangelidis, A. Deleforge, and R. Horaud ,  "Head Pose Estimation via Probabilistic High-Dimensional Regression", IEEE International Conference on Image Processing (ICIP), 2015.



addpath('GLLiM');
addpath('mArrow');
data_path = 'your path to the prima database';
eval(['mkdir ' data_path 'matlab_data']);

%% Process the database
data = processPrima(data_path);
% data = processPrimaDetection(data_path);
save([data_path 'data.mat'],'data','-v7.3');
%% Learn the models
load([data_path 'matlab_data/data.mat']);
K = 50; Lv = 0;% parameter for the gllim model (K:number of affine transformation, Lv: dimension of the latent part)
theta = learnPrima(data,K,Lv);
save([data_path 'theta.mat'],'theta','-v7.3');

%% test
[estimation,error] = estimatePrima(data,theta);% give estimation and absolute error for each angles
